#ifndef CLASS_CONFIG_H
#define CLASS_CONFIG_H

#include "st_common.h"
#include "character/classplayer.h"

/**
 * @brief
 *
 */
enum e_tank_type {TANK_ENERGY, TANK_WEAPON, TANK_SPECIAL};

// ********************************************************************************************** //
// This class handles all configuration menus and in-game weapon and item selection screen        //
// ********************************************************************************************** //
/**
 * @brief
 *
 */
class class_config
{
public:
	class_config();
    /**
     * @brief
     */
    void draw_ingame_menu();
    /**
     * @brief
     * @param set_player_ref
     * @return bool
     */
    bool execute_ingame_menu();
    /**
     * @brief
     * @param set_player_ref
     */
    void set_player_ref(classPlayer* set_player_ref);
    /**
     * @brief
     *
     * @param menu_pos
     * @return WEAPON_ICONS_ENUM
     */
    enum WEAPON_ICONS_ENUM convert_menu_pos_to_weapon_n(st_position menu_pos);
    /**
     * @brief
     *
     * @param wpn_n
     * @return st_position
     */
    st_position convert_weapon_n_to_menu_pos(int wpn_n);

private:
    /**
     * @brief
     *
     * @param x_inc
     * @param y_inc
     */
    void move_cursor(int x_inc, int y_inc);
    /**
     * @brief
     *
     * @return st_position
     */
    st_position move_weapon_curstor_left();
    /**
     * @brief
     *
     * @return st_position
     */
    st_position move_weapon_curstor_right();
    /**
     * @brief
     *
     * @return st_position
     */
    st_position move_weapon_curstor_up();
    /**
     * @brief
     *
     * @return st_position
     */
    st_position move_weapon_curstor_down();

    /**
     * @brief
     *
     */
    void change_player_frame_color();
    /**
     * @brief
     *
     * @param tank_type
     */
    void use_tank(int tank_type);

private:
    bool ingame_menu_active; /**< TODO */
    st_position ingame_menu_pos; /**< TODO */
    classPlayer* player_ref; /**< TODO */
    graphicsLib_gSurface _player_surface; /**< TODO */
};

#endif // CLASS_CONFIG_H
