#include "weapon_edit.h"
#include "ui_weapon_edit.h"

#include "common.h"

weapon_edit::weapon_edit(QWidget *parent) :
QWidget(parent),
ui(new Ui::weapon_edit), _selected_weapon(0), _loaded(false)
{
	ui->setupUi(this);
	reload_weapon_list();
    common::fill_weapons_combo(ui->weapon_select_combo);
    common::fill_projectiles_combo(ui->weapon_projectile_type);
	_loaded = true;
}

weapon_edit::~weapon_edit()
{
    delete ui;
}

void weapon_edit::reload()
{
    _loaded = false;
    _selected_weapon = 0;
    reload_weapon_list();
    common::fill_weapons_combo(ui->weapon_select_combo);
    common::fill_projectiles_combo(ui->weapon_projectile_type);
    _loaded = true;
}

void weapon_edit::reload_weapon_list()
{
    common::fill_weapons_combo(ui->weapon_select_combo);
}

void weapon_edit::on_weapon_select_combo_currentIndexChanged(int index)
{
	_selected_weapon = index;
	ui->weapon_name->setText(QString(game_data.weapons[_selected_weapon].name));
	ui->weapon_damage->setValue(game_data.weapons[_selected_weapon].damage);
	ui->weapon_projectile_type->setCurrentIndex(game_data.weapons[_selected_weapon].id_projectile);
}

void weapon_edit::on_weapon_name_textChanged(const QString &arg1)
{
	sprintf(game_data.weapons[_selected_weapon].name, "%s", arg1.toStdString().c_str());
	//reload_weapon_list();
}

void weapon_edit::on_weapon_projectile_type_currentIndexChanged(int index)
{
	game_data.weapons[_selected_weapon].id_projectile = index;
}

void weapon_edit::on_weapon_damage_valueChanged(int arg1)
{
	game_data.weapons[_selected_weapon].damage = arg1;
}

void weapon_edit::on_weapon_name_lostFocus()
{
	reload_weapon_list();
}
