#include <cstdlib>
#include "file_io.h"

extern std::string FILEPATH;

file_io::file_io()
{
}

void file_io::write_game(format_v2_0::file_game& data_in) {
	std::ofstream fp;
	std::string filename = std::string(FILEPATH) + "data/game_001.dat";

	fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
	if (!fp.is_open()) {
		std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
		return;
	}

	std::cout << "############ file_io::write_game - graphic_filename: " << data_in.game_npcs[0].graphic_filename << std::endl;

	fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v2_0::file_game));
    fp.close();
}

bool file_io::file_exists(std::string filename)
{
    //std::cout << "file_io::file_exists::START" << std::endl;
    bool res = false;
    /*
    std::ifstream file(filename.c_str());
    if (file) {
        res = true;
    }
    */
    FILE *fp;
    fp = fopen(filename.c_str(), "rb");
    if (fp) {
        //std::cout << "file_io::file_exists - TRUE" << std::endl;
        res = true;
        fclose(fp);
    //} else {
        //std::cout << "file_io::file_exists - FALSE" << std::endl;
    }
    return res;
}

void file_io::read_game(format_v2_0::file_game& data_out) {
	std::ifstream fp;
	std::string filename = std::string(FILEPATH) + "data/game_001.dat";

	//std::cout << "file_io::read_game - filename: " << filename << std::endl;

	fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
	if (!fp.is_open()) {
		std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
		exit(-1);
	}

	fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v2_0::file_game));

	std::cout << "############ file_io::write_game - graphic_filename: " << data_out.game_npcs[0].graphic_filename << std::endl;

	fp.close();
}

namespace format_v_2_0_1 {

	file_io::file_io()
	{
	}

	void file_io::write_game(format_v_2_0_1::file_game& data_in) {
		std::ofstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v201_001.dat";

		fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
		if (!fp.is_open()) {
			std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
			return;
		}

		std::cout << "############ file_io::write_game(format_v_2_0_1) - graphic_filename: " << data_in.game_npcs[0].graphic_filename << std::endl;
		fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_0_1::file_game));
		fp.close();
	}


	void file_io::read_game(format_v_2_0_1::file_game& data_out) {
		std::ifstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v201_001.dat";

		//std::cout << "file_io::read_game - filename: " << filename << std::endl;

		fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
		if (!fp.is_open()) {
			std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
			exit(-1);
		}

		fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v_2_0_1::file_game));

		fp.close();
	}



	bool file_io::save_exists()
	{
		std::ifstream fp;
		std::string filename = std::string(FILEPATH) + "data/game.sav";

		//std::cout << "file_io::read_game - save_exists: " << filename << std::endl;

		fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
		if (!fp.is_open()) {
			std::cout << "WARNING::save_exists - could not open save file '" << filename << std::endl;
			return false;
		}
		return true;
	}

	void file_io::read_save(format_v_2_0_1::st_save& data_out)
	{
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/game.sav";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            fclose(fp);
            exit(-1);
        }
        fread(&data_out, sizeof(struct format_v_2_0_1::st_save), 1, fp);
        // ------- DEBUG ------- //
        /*
        for (int i=0; i<STAGE_COUNT; i++) {
            data_out.stages[i] = 1;
        }
        */
        fclose(fp);
	}

	void file_io::write_save(format_v_2_0_1::st_save& data_in)
	{
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "/data/game.sav";
        fp = fopen(filename.c_str(), "wb");
        if (!fp) {
            std::cout << "Error: Could not open save-file '" << filename << "'." << std::endl;
            exit(-1);
        }
        fwrite(&data_in, sizeof(struct format_v_2_0_1::st_save), 1, fp);
        fclose(fp);
	}

}


namespace format_v_2_0_2 {

	file_io::file_io()
	{
	}

	void file_io::write_game(format_v_2_0_2::file_game& data_in) {
		std::ofstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v202_001.dat";

		fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
		if (!fp.is_open()) {
			std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
			return;
		}

		fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_0_2::file_game));
		fp.close();
	}


	void file_io::read_game(format_v_2_0_2::file_game& data_out) {
		std::ifstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v202_001.dat";

		fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
		if (!fp.is_open()) {
			std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
			exit(-1);
		}

		fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v_2_0_2::file_game));

		fp.close();
	}

}


namespace format_v_2_0_3 {

	file_io::file_io()
	{
	}

	void file_io::write_game(format_v_2_0_3::file_game& data_in) {
		std::ofstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v203_001.dat";

		fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
		if (!fp.is_open()) {
			std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
			return;
		}

		fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_0_3::file_game));
		fp.close();
	}


	void file_io::read_game(format_v_2_0_3::file_game& data_out) {
		std::ifstream fp;
		std::string filename = std::string(FILEPATH) + "data/game_v203_001.dat";

		fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
		if (!fp.is_open()) {
			std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
			exit(-1);
		}

		fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v_2_0_3::file_game));

		fp.close();
	}

}


namespace format_v_2_0_4 {

    file_io::file_io()
    {
    }

    void file_io::write_game(format_v_2_0_4::file_game& data_in) {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v204_001.dat";

        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        }

        fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_0_4::file_game));
        fp.close();
    }


    void file_io::read_game(format_v_2_0_4::file_game& data_out) {
        std::ifstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v204_001.dat";

        fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
        if (!fp.is_open()) {
            std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
            exit(-1);
        }

        fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v_2_0_4::file_game));

        fp.close();
    }


}


namespace format_v_2_1 {

    file_io::file_io()
    {
    }

    void file_io::write_game(format_v_2_1::file_game& data_in) {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v21.dat";

        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        }

        fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_1::file_game));
        fp.close();
    }


    void file_io::read_game(format_v_2_1::file_game& data_out) {
        std::ifstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v21.dat";

        fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
        if (!fp.is_open()) {
            std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
            exit(-1);
        }

        fp.read(reinterpret_cast<char *>(&data_out), sizeof(struct format_v_2_1::file_game));

        fp.close();
    }
}


namespace format_v_2_1_1 {

    file_io::file_io()
    {
    }

    void file_io::write_game(format_v_2_1_1::file_game& data_in) {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v211.dat";

        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }

        fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_1_1::file_game));
        fp.close();

        // ----------------------- STAGES ----------------------- //

    }

    void file_io::write_all_stages(format_v_2_1_1::file_stages &stages_data_in)
    {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }
        fp.write(reinterpret_cast<char *>(&stages_data_in), sizeof(struct format_v_2_1_1::file_stages));
        fp.close();
    }



    void file_io::read_game(format_v_2_1_1::file_game& data_out) {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/game_v211.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            exit(-1);
        }
        fread(&data_out, sizeof(struct format_v_2_1_1::file_game), 1, fp);
        fclose(fp);
    }


    void file_io::read_all_stages(format_v_2_1_1::file_stages& stages_data_out)
    {
        std::ifstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
        if (!fp.is_open()) {
            std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
            exit(-1);
        }
        fp.read(reinterpret_cast<char *>(&stages_data_out), sizeof(struct format_v_2_1_1::file_stages));
        fp.close();
    }

    void file_io::read_stage(format_v_2_0_3::file_stage &stages_data_out, short stage_n)
    {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            fclose(fp);
            exit(-1);
        }
        fseek(fp, sizeof(format_v_2_0_3::file_stage) * stage_n, SEEK_SET);
        fread(&stages_data_out, sizeof(struct format_v_2_0_3::file_stage), 1, fp);
        fclose(fp);

    }


}


