#ifndef GAME_H
#define GAME_H

#include <map>
#include <vector>
#include <sstream>
#include <string>

class classPlayer;
class classnpc;


#include "character/classplayer.h"
#include "character/classnpc.h"
#include "sceneslib.h"
#include "stage.h"
#include "objects/object.h"
#include "class_config.h"
#include "scenes/dialogs.h"



/**
 * @brief
 *
 */
class game
{
public:
/**
 * @brief
 *
 */
    game();
    /**
     * @brief
     *
     */
    ~game();
    /**
     * @brief
     *
     */
    void initGame();
    /**
     * @brief
     *
     * @return bool
     */
    bool showIntro();
    /**
     * @brief
     *
     */
    void quick_load_game();
    /**
     * @brief
     *
     * @param can_characters_move
     */
    void showGame(bool can_characters_move=true);
    /**
     * @brief
     *
     * @param st_position
     * @return int
     */
    int getMapPointLock(struct st_position);
    /**
     * @brief
     *
     */
    void framerate_limiter();
    /**
     * @brief
     *
     * @return st_position
     */
    st_position checkScrolling();
    /**
     * @brief
     *
     */
    void fps_count();
    /**
     * @brief
     *
     * @param tileX
     * @param tileY
     * @param is_door
     * @param playerObj
     */
    void horizontal_transition_screen(int tileX, int tileY, bool is_door, character* playerObj);
    /**
     * @brief
     *
     * @param direction
     * @param is_door
     * @param tileX
     * @param tileY
     */
    void horizontal_screen_move(short direction, bool is_door, short tileX, short tileY);
    /**
     * @brief
     *
     */
    void got_weapon();
    /**
     * @brief
     *
     */
    void leave_stage();
    /**
     * @brief
     *
     */
    void show_ending();
    /**
     * @brief
     *
     * @param centerX
     * @param centerY
     * @param show_players
     */
    void draw_explosion(short int centerX, short int centerY, bool show_players);
    /**
     * @brief
     *
     * @param centerX
     * @param centerY
     */
    void draw_implosion(short int centerX, short int centerY);
	// PLAYER methods
    /**
     * @brief
     *
     * @param player_n
     */
    void show_player(short int player_n);
    /**
     * @brief
     *
     * @param pos
     * @param player_n
     */
    void set_player_position(st_position pos, short int player_n);
    /**
     * @brief
     *
     * @param xinc
     * @param yinc
     * @param player_n
     */
    void change_player_position(short xinc, short yinc, short player_n);
    /**
     * @brief
     *
     * @param anim_type
     * @param player_n
     */
    void set_player_anim_type(short int anim_type, short int player_n);
    /**
     * @brief
     *
     * @param player_n
     * @return st_position
     */
    st_position get_player_position(short int player_n);
    /**
     * @brief
     *
     * @param player_n
     * @return st_size
     */
    st_size get_player_size(short int player_n);
    /**
     * @brief
     *
     * @param direction
     * @param player_n
     */
    void set_player_direction(short int direction, short int player_n);
    /**
     * @brief
     *
     * @param player_n
     */
    void player_fall(short int player_n);
    /**
     * @brief
     *
     * @param show_dialog
     */
    void boss_intro(bool show_dialog);
    /**
     * @brief
     *
     * @return object
     */
    object* get_player_platform();
    /**
     * @brief
     *
     */
    void check_player_return_teleport(); // if player is inside a teleporter, killing a boss makes him teleport out
    /**
     * @brief
     *
     * @return bool
     */
    bool must_show_boss_hp();
    /**
     * @brief
     *
     */
    void fill_boss_hp_bar();
    /**
     * @brief
     *
     */
    void reset_stage_maps();
    /**
     * @brief
     *
     */
    void remove_all_projectiles();
    /**
     * @brief
     *
     */
    void show_map();
    /**
     * @brief
     *
     * @param int
     */
    void set_current_map(int);
    /**
     * @brief
     *
     */
    void th_move_npcs();
    /**
     * @brief
     *
     * @param n
     * @return classPlayer
     */
    classPlayer* get_player(int n);
    /**
     * @brief
     *
     * @return st_position
     */
    st_position get_current_stage_scroll();
    /**
     * @brief
     *
     */
    void reset_scroll();
    /**
     * @brief
     *
     * @param type
     * @return short
     */
    short get_drop_item_id(short type);
    /**
     * @brief
     *
     */
    void get_drop_item_ids();
    /**
     * @brief
     *
     * @param finished_stage
     */
    void show_config(short finished_stage);


private:
    /**
     * @brief
     *
     * @param test_player
     * @return bool
     */
    bool test_teleport(classPlayer *test_player);
    /**
     * @brief
     *
     */
    void debug_draw_map_links();
    /**
     * @brief
     *
     */
    void start_stage();
    /**
     * @brief
     *
     */
    void restart_stage();
	//void load_game_objects();
    /**
     * @brief
     *
     * @param n
     * @return std::string
     */
    std::string cent_number(int n);
    /**
     * @brief
     *
     * @param type
     * @param map_n
     * @param adjust_x
     * @param pObj
     */
    void transitionScreen(short int type, short int map_n, short int adjust_x, classPlayer *pObj);
    /**
     * @brief
     *
     * @return short
     */
    short int get_current_map();
    /**
     * @brief
     *
     * @param char_obj
     * @param pos_x
     */
    void walk_character_to_screen_point_x(character* char_obj, short pos_x); // keeps walking (and jumping obstacles) until reaching a given point in screen (not in map, that should have its own function for that)
    /**
     * @brief
     *
     * @param set_teleport_n
     * @param set_player_pos
     */
    void set_player_teleporter(short set_teleport_n, st_position set_player_pos);
    /**
     * @brief
     *
     * @return bool
     */
    bool is_player_on_teleporter();
    /**
     * @brief
     *
     * @return used_teleporter
     */
    used_teleporter get_player_teleporter();
    /**
     * @brief
     *
     */
    void finish_player_teleporter();
    /**
     * @brief
     *
     * @param wait_time
     * @param move_npcs
     */
    void show_stage(int wait_time, bool move_npcs);


public:
    int currentStage; /**< TODO */
    bool is_showing_boss_intro; /**< TODO */


private:
    stage* loaded_stage; /**< TODO */
    std::vector<classPlayer> players; /**< TODO */
    scenesLib scenes; /**< TODO */
    unsigned int fps_timer; /**< TODO */
    int fps_counter; /**< TODO */
    std::stringstream fps_msg; /**< TODO */
    char _fps_buffer[128]; /**< TODO */
    struct format_v_2_1_1::st_game_config config; /**< TODO */
    st_position selected_stage; /**< TODO */
	//std::map<std::string, object> game_object_list;
    class_config config_manager; /**< TODO */
    dialogs game_dialogs; /**< TODO */
	// framerate timers
    int _t1; /**< TODO */
    float _frame_duration; /**< TODO */
    std::map<short, bool> _last_stage_used_teleporters; // list of used teleportes (they do not work anymore after added to this list) /**< TODO */
    used_teleporter _player_teleporter; /**< TODO */
    bool _show_boss_hp; // after set to true, will keep showing the boss HP bar on screen right side /**< TODO */

    short _drop_item_list[DROP_ITEM_COUNT]; /**< TODO */
    bool invencible_old_value; // used to store flag value in order we don't loose it when setting to true due to temporary "got weapon" invencibility /**< TODO */

};

#endif // GAME_H
