#ifndef OBJECT_H
#define OBJECT_H

#include <string>
#include <map>
#include "graphicslib.h"

class classMap; // forward declaration

/**
 * @brief
 *
 */
class object
{
public:
	//object(int id, struct format_v_2_1::file_object temp_obj); // game object constructor
	object(int _id, classMap *set_map, st_position map_pos); // map object constructor
    /**
     * @brief
     *
    */
    void reset();
    /**
     * @brief
     *
     */
    void show();
    /**
     * @brief
     *
     */
    void move();
    /**
     * @brief
     *
     */
    void execute();
    /**
     * @brief
     *
     * @return st_position
     */
    st_position get_position();
    /**
     * @brief
     *
     * @return st_size
     */
    st_size get_size();
    /**
     * @brief
     *
     * @return short
     */
    short int get_type();
    /**
     * @brief
     *
     * @return int
     */
    int get_direction();
    /**
     * @brief
     *
     * @param int
     */
    void set_direction(int);
    /**
     * @brief
     *
     * @return int
     */
    int get_distance();
    /**
     * @brief
     *
     * @param int
     */
    void set_distance(int);
    /**
     * @brief
     *
     * @param int
     */
    void set_timer(int);
    /**
     * @brief
     *
     * @return unsigned int
     */
    unsigned int get_timer();
    /**
     * @brief
     *
     * @return bool
     */
    bool finished();
    /**
     * @brief
     *
     * @param is_finished
     */
    void set_finished(bool is_finished);
    /**
     * @brief
     *
     */
    void invert_direction_x();
    /**
     * @brief
     *
     */
    void invert_direction_y();
    /**
     * @brief
     *
     * @param obj_state
     */
    void set_state(short obj_state);
    /**
     * @brief
     *
     * @return short
     */
    short get_state();
    /**
     * @brief
     *
     * @param duration
     */
    void set_duration(int duration);
    /**
     * @brief
     *
     */
    void start();
    /**
     * @brief
     *
     */
    void command_up();															// some objects can be controlled by the player
    /**
     * @brief
     *
     */
    void command_down();														// some objects can be controlled by the player
    /**
     * @brief
     *
     * @return std::string
     */
    std::string get_name();
    /**
     * @brief
     *
     * @return bool
     */
    bool is_hidden();
    /**
     * @brief
     *
     * @return bool
     */
    bool is_started();
    /**
     * @brief
     *
     * @return bool
     */
    bool is_on_screen();
    /**
     * @brief
     *
     * @return int
     */
    int get_duration();


    /**
     * @brief
     *
     * @param colision_mode
     */
    void set_colision_mode(enum colision_modes colision_mode); // if player uses this as platform, move him

    enum colision_modes get_colision_mode();

private:
    /**
     * @brief
     *
     */
    void add_graphic();
    /**
     * @brief
     *
     */
    void gravity();
    /**
     * @brief
     *
     * @param xinc
     * @param yinc
     * @return bool
     */
    bool test_change_position(short int xinc, short int yinc);
    /**
     * @brief
     *
     * @param xinc
     * @param yinc
     */
    void check_player_move(int xinc, int yinc); // if player uses this as platform, move him




private:
    unsigned int _id; /**< TODO */
    std::string name; /**< TODO */
    std::string graphic_filename;												// graphic file used on it /**< TODO */
    short int type; /**< TODO */
    unsigned int obj_timer;														// used as time for disapearing block /**< TODO */
    int speed;																	// used as speed for moving platform /**< TODO */
    int limit;																	// used as range (pixels) for moving platform, visible time for disapearing block /**< TODO */
    int direction;																// used to check if moving away from oiginalpoint or moving to it /**< TODO */
    int distance; /**< TODO */
    int framesize_w; /**< TODO */
    int framesize_h; /**< TODO */
    int frame;																	// indicates what is the used frame /**< TODO */
    struct st_position start_point; /**< TODO */
    struct st_position position; /**< TODO */
    static std::map<unsigned int, graphicsLib_gSurface> objects_sprite_list; /**< TODO */
    classMap *map;																// reference to the map this object is in /**< TODO */
    bool _started;																// some object types will only start to act/move after player interaction /**< TODO */
    bool _finished;																// indicates to map->show() that the object must be deleted /**< TODO */
    short _state; /**< TODO */
    unsigned int _duration; /**< TODO */
    unsigned int _timer_limit; /**< TODO */
    bool _command_up; /**< TODO */
    bool _command_down; /**< TODO */
    bool _animation_finished; /**< TODO */
    bool _animation_reversed; /**< TODO */
    bool _hidden; /**< TODO */
    enum colision_modes _colision_mode;
};

#endif // OBJECT_H
